-- Author: Skylar011@gmail.com

function SkyUI_CreateClass(parent)
 local class = { prototype = {} }
 if parent then class.super = parent setmetatable(class.prototype, { __index = parent.prototype }) end
 local mt = { __index = class.prototype }
 function class:new(...)
  local self = setmetatable({}, mt)
  if self.init then self:init(...) end
  return self
 end
 return class
end

SkyUI = {}
local sui = SkyUI

local function tcopy(to, from)   -- "to" must be a table (possibly empty)
 for k,v in pairs(from) do if type(v) == "table" then if type(to[k]) ~= "table" then to[k] = {} end tcopy(to[k], v) else to[k] = v end end
end

sui.Modules = {
 UnitFrames = {
  Initialized = false, Enabled = false,
  Auras = {
   Enabled = false,
   Bars = { Enabled = false },
   CD = { Enabled = false }
  }
 },
 ActionBars = { Initialized = false, Enabled = false },
 ComboPoints = { Initialized = false, Enabled = false },
 PartyFrames = { Initialized = false, Enabled = false },
 Main = {}
}

sui.Graphics = { -- Textures
 Btn =	{ Path = "Interface\\addons\\SkyUI\\Textures\\SkyUI", W = 512, H = 512 },
 Units = { Path = "Interface\\addons\\SkyUI\\Textures\\SkyUI_unitFrames", W = 512, H = 512 },
}

sui.Fonts = {
 Nasalization = "Interface\\addons\\SkyUI\\Fonts\\nasalization.ttf", -- ActionFrames
 Marken = "Interface\\addons\\SkyUI\\Fonts\\MARKEN__.TTF",
 Liberation = "Interface\\addons\\SkyUI\\Fonts\\LiberationSans-Regular.ttf",
}

-- these are mostly needed for a fallback case (in case the code tries to index a power token that is missing from the table,
-- it will try to index by power type instead)




sui.PBC = { -- PowerBarColors
 MANA = { r = 0, g = 0, b = 1, a = 1, rT = 0.14, gT = 0.35, bT = 1 };
 RAGE = { r = 1.00, g = 0.00, b = 0.00, rT = 1.00, gT = 0.00, bT = 0.00,  };
 FOCUS = { r = 1.00, g = 0.50, b = 0.25,  rT = 1.00, gT = 0.50, bT = 0.25 };
 ENERGY = { r = 1.00, g = 1.00, b = 0.00, rT = 1.00, gT = 1.00, bT = 0.00 };
 COMBO_POINTS = { r = 1.00, g = 1.00, b = 0.00, rT = 1.00, gT = 1.00, bT = 0.00 };

 CHI = { r = 0.71, g = 1.0, b = 0.92, rT = 0.71, gT = 1.0, bT = 0.92 };
 RUNES = { r = 0.50, g = 0.50, b = 0.50, rT = 0.50, gT = 0.50, bT = 0.50 };
 RUNIC_POWER = { r = 0.00, g = 0.82, b = 1.00, rT = 0.00, gT = 0.82, bT = 1.00 };
 SOUL_SHARDS = { r = 0.50, g = 0.32, b = 0.55, rT = 0.50, gT = 0.32, bT = 0.55 };
 LUNAR_POWER = { negative = { r = 0.30, g = 0.52, b = 0.90, rT = 0.30, gT = 0.52, bT = 0.90 },  positive = { r = 0.80, g = 0.82, b = 0.60, rT = 0.80, gT = 0.82, bT = 0.60 }};
 HOLY_POWER = { r = 0.95, g = 0.90, b = 0.60, rT = 0.95, gT = 0.90, bT = 0.60 };

 MAELSTROM = { r = 0.00, g = 0.50, b = 1.00, atlas = "_Shaman-MaelstromBar", fullPowerAnim=true };
 INSANITY = { r = 0.40, g = 0, b = 0.80, atlas = "_Priest-InsanityBar"};
 ARCANE_CHARGES = { r = 0.1, g = 0.1, b = 0.98 };
 FURY = { r = 0.788, g = 0.259, b = 0.992, rT = 0.788, gT = 0.259, bT = 0.992, atlas = "_DemonHunter-DemonicFuryBar", fullPowerAnim=true };
 PAIN = { r = 255/255, g = 156/255, b = 0, atlas = "_DemonHunter-DemonicPainBar", fullPowerAnim=true };
 AMMOSLOT = { r = 0.80, g = 0.60, b = 0.00 };
 FUEL = { r = 0.0, g = 0.55, b = 0.5 };
 STAGGER = { {r = 0.52, g = 1.0, b = 0.52}, {r = 1.0, g = 0.98, b = 0.72}, {r = 1.0, g = 0.42, b = 0.42},};
 
}


sui.PBC[0] = sui.PBC["MANA"];
sui.PBC[1] = sui.PBC["RAGE"];
sui.PBC[2] = sui.PBC["FOCUS"];
sui.PBC[3] = sui.PBC["ENERGY"];
sui.PBC[4] = sui.PBC["CHI"];
sui.PBC[5] = sui.PBC["RUNES"];
sui.PBC[6] = sui.PBC["RUNIC_POWER"];
sui.PBC[7] = sui.PBC["SOUL_SHARDS"];
sui.PBC[8] = sui.PBC["LUNAR_POWER"];
sui.PBC[9] = sui.PBC["HOLY_POWER"];
sui.PBC[11] = sui.PBC["MAELSTROM"];
sui.PBC[13] = sui.PBC["INSANITY"];
sui.PBC[17] = sui.PBC["FURY"];
sui.PBC[18] = sui.PBC["PAIN"];




sui.Clr = {
 None = {r = 1, g = 1, b = 1, a = 1},
 HealthFriendly = {r = 0, g = 1, b = 0.125, a = 1},
 HealthIncoming = {r = 0, g = .4, b = .95, a = 1},
 HealthHostile = {r = 0.95, g = 0.05, b = 0.05, a = 1},
 HealthHostileIncoming = {r = 0.75, g = 0.05, b = 0.05, a = 1},
 HealthNeutral = {r = 0.75, g = 0.75, b = 0.75, a = 1},
 Mana = {r = 0, g = 0.72265625, b = 0.92578125, a = 1},
 Energy = {r = 1, g = 1, b = 0, a = 1},
 Combo = {r = 1, g = 1, b = 0, a = 0},
 Transparent = {r = 1, g = 1, b = 1, a = 0},
 Buff = {r = 0, g = 0.5, b = 0.5 },
 Debuff = {r = 0.5, g = 0, b = 1 },
 Dark = { r = 0.2, g = 0.2, b = 0.2, a = 1 },
 Dark2 = { r = 0.25, g = 0.25, b = 0.25, a = 1 },
 PartyFrame = { r = 0.3, g = 0.3, b = 0.3, a = 1 },
 Elite = { r = 1, g = 0.84314, b = 0, a = 1 },
}
local Clr = sui.Clr

sui.Strings = {
 Header = { Font = SkyUI.Fonts.Liberation, Size = 12, Flags = "" },
 Title = { Font = SkyUI.Fonts.Liberation, Size = 12, Flags = "" }
}
sui.Structs = { By = { Default = 0, Class = 1, Threat = 2 } }


sui.Config = {}
sui.ConfigDefaults = {
 UnitFrames = {
  UI =              { Enabled = true, OffsetX = 0, OffsetY = 0,  player = { Enabled = true, OOCAlpha = 1, CombatAlpha = 1, }, target = { Enabled = true, InsideAlpha = 1, OutsideAlpha = 0.7 }, },
  Auras =           {
   Enabled = true,
   Swap = false,
   CooldownBackdrop = true,
   Buffs = { Enabled = true, Bars = true, CD = true, Names = true, MinCD = 3, MaxCD = 15, Max = 8 },
   Debuffs = { Enabled = true, Bars = true, CD = true, Names = true, MinCD = 3, MaxCD = 15, Max = 8 }
  },
  ColorOptions = {
   Health = sui.Structs.By.Default,
   Mana = sui.Structs.By.Default
  },
  RangeTransparency = true,
  playerpet =       { Enabled = true },
  playerpettarget = { Enabled = true },
  targetpet =       { Enabled = true, },
  targetpettarget = { Enabled = true, },
  focus =           { Enabled = true, },
  targettarget =    { Enabled = true, },


 },
 ComboPoints = { UI = { Enabled = true, OffsetX = 0, OffsetY = 0 }, },
 PartyFrames = { UI = { Enabled = true, OffsetX = 0, OffsetY = 0 }, },
}
tcopy(sui.Config, sui.ConfigDefaults)

sui.Specs = {
 UnitFrames = {
  Enabled = true,
  TextureSheet = sui.Graphics.Units,
  TextureOffset = {X = -36, Y = 111}, -- Location of frame textures in relation to the spritesheet being used
  Frames = { --[ Anchor, OffsetX, OffsetY, Width, Height, X1,X2,Y1,Y2 ] :: Hitbox for the unit frames
   Player = { RT = "CENTER", X = -250, Y = -100, W = 70, H = 45 }, -- 230
   Target = { RT = "CENTER", X = 250, Y = -100, W = 70, H = 45 }, -- 222
  --   Party = {	bgTexture = { X = 0, Y = 0 },	RT = "TOPLEFT", X = 20, Y = 150, W = 140, H = 37, tX = 289, tY = 162	},
  },
  Unit = { -- Unit Frame Setup
   Textures = {
    -- [ OffsetX, OffsetY, X, Y, Width, Height, Layer, DefaultVertexColor ]
    -- 181,267
    BG = { X = 0, Y = 0.5, tX = 0, tY = 0, W = 206, H = 269, L = "BACKGROUND", Clr = Clr.Dark },

    Health = { X = 3, Y = -6.5, tX = 221, tY = 7, W = 143, H = 164, L = "ARTWORK", Clr = Clr.HealthFriendly },
    IncomingHealth = { X = 3, Y = -6.5, tX = 221, tY = 7, W = 143, H = 164, L = "BORDER", Clr = Clr.HealthIncoming },

    Power = { X = 80.5, Y = -160.5, tX = 79, tY = 268, W = 86, H = 86, L = "ARTWORK", Clr = Clr.None },

    CastBar = { X = 150, Y = -179.5, tX = 0,tY =  374, W = 169, H = 23, L = "BACKGROUND", Clr = Clr.Dark },
    Cast = { X = 156.5, Y = -185.5, tX = 6, tY = 397, W = 135, H = 11, L = "ARTWORK" },
    CastIconOverlay = { X = 294.5, Y = -182.5, tX = 169, tY = 376, W = 17, H = 17, L = "ARTWORK" },

    NameSpannerL = { X = 151.5, Y = -182.5, tX = 222, tY = 184, W = 15, H = 18, L = "BACKGROUND", Clr = Clr.Dark2 },
    NameSpannerS = { X = 166.5, Y = -182.5, tX = 241, tY = 184, W = 1, H = 18, L = "BACKGROUND", Clr = Clr.Dark2 },
    NameSpannerR = { X = 167.5, Y = -182.5, tX = 242, tY = 184, W = 15, H = 18, L = "BACKGROUND", Clr = Clr.Dark2 },

    HealthSpannerL = { X = 0+60, Y = -94.5, tX = 383, tY = 184, W = 7, H = 16, L = "BACKGROUND", Clr = Clr.Dark },
    HealthSpannerS = { X = -1+60, Y = -94.5, tX = 390, tY = 184, W = 1, H = 16, L = "BACKGROUND", Clr = Clr.Dark },
    HealthSpannerR = { X = 0+60, Y = -94.5, tX = 391, tY = 184, W = 15, H = 16, L = "BACKGROUND", Clr = Clr.Dark },

    PowerSpannerL = { X = -7.5+69, Y = -76.5-82, tX = 383, tY = 184, W = 7, H = 16, L = "BACKGROUND", Clr = Clr.Dark },
    PowerSpannerS = { X = 1.5+69, Y = -76.5-82, tX = 390, tY = 184, W = 1, H = 16, L = "BACKGROUND", Clr = Clr.Dark },
    PowerSpannerR = { X = 2.5+69, Y = -76.5-82, tX = 391, tY = 184, W = 15, H = 16, L = "BACKGROUND", Clr = Clr.Dark },

    --   ClassColorStrip = { X = 163, Y = -203.5, tX = 222, tY = 204, W = 41, H = 13, L = "ARTWORK" },
    ClassColorStrip = { X = 116, Y = -152.5, tX = 7, tY = 439, W = 88, H = 64, L = "ARTWORK" },
    
    -- Classification = { X = 0, Y = 0, tX = 427, tY = 407, W = 78, H = 62, L = "ARTWORK" },
    Classification = { X = 13, Y = -107, tX = 427, tY = 68, W = 78, H = 62, L = "ARTWORK", Sub = 1 },
    
    BuffBar = { Skip = true, X = 37, Y = -33.5, tX = 279, tY = 268, W = 111, H = 112, L = "BACKGROUND", Clr = Clr.Dark2},
    Buff = { Skip = true, X = 45, Y = -36.5, tX = 348, tY = 380, W = 101, H = 101, L = "ARTWORK", Clr = Clr.Buff},
    BuffIconBG = { Skip = true, X = 149, Y = -33.5, tX = 262, tY = 333, W = 15, H = 15, L = "BACKGROUND" },

    DebuffBar = { Skip = true, X = 90, Y = -191.5, tX = 182, tY = 268, W = 80, H = 81, L = "BACKGROUND", Clr = Clr.Dark2},
    Debuff = { Skip = true, X = 97, Y = -194.5, tX = 240, tY = 380, W = 70, H = 70, L = "ARTWORK", Clr = Clr.Debuff},
    DebuffIconBG = { Skip = true, X = 149, Y = -191.5, tX = 262, tY = 333, W = 15, H = 15, L = "BACKGROUND" },

    AuraBuff = { Skip = true, X = 149, Y = -146.5, tX = 262, tY = 333, W = 15, H = 15, L = "BACKGROUND", Clr = Clr.Transparent },
    AuraDebuff = { Skip = true, X = 170, Y = -240.5, tX = 262, tY = 333, W = 15, H = 15, L = "BACKGROUND", Clr = Clr.Dark },

    --      AuraDebuff = { Skip = nil, X = 149, Y = -163.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },
    -- 			Aura4 = { Skip = nil, X = 170, Y = -223.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },
    -- 			Aura5 = { Skip = nil, X = 170, Y = -206.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },

    --    PetBG = { X = 200, Y = 240.5, tX = 372, tY = 142, W = 111, H = 29, L = "BACKGROUND" },

-- 410 21 - 38,19
-- 406 28 - 34,26
--    PetBG = { X = 200, Y = -280.5, tX = 372, tY = 142, W = 111, H = 29, L = "BACKGROUND", Clr = Clr.Dark },
--    PetHealth = { X = 228, Y = -293.5, tX = 400, tY = 127, W = 80, H = 8, L = "ARTWORK", Clr = Clr.HealthFriendly },
--    PetPower = { X = 228, Y = -302.5, tX = 400, tY = 136, W = 80, H = 4, L = "ARTWORK", Clr = Clr.Energy }, -- change to transparent!
--232 105
    PetBG = {               X = 200-232,              Y = -280.5+105,       tX = 372, tY = 2,  W = 129, H = 35, L = "BACKGROUND", Clr = Clr.Dark2 },
    PetHealth = {           X = 238-232,              Y = -280.5-19+105,    tX = 396, tY = 38, W = 81,  H = 6, L = "ARTWORK", Clr = Clr.HealthFriendly },
    PetPower = {            X = 234-232,              Y = -280.5-26+105,    tX = 396, tY = 45, W = 78,  H = 3, L = "ARTWORK", Clr = Clr.Energy }, -- change to transparent!
    PetLvlBG = {              X = 188-232,              Y = -280.5-11+105,    tX = 372, tY = 38, W = 22,  H = 13, L = "ARTWORK", Clr = Clr.Dark2, Sub = 1 },

    PetTargetBG = {         X = 200-232,              Y = -347.5+132,       tX = 372, tY = 2,  W = 129, H = 35, L = "BACKGROUND", Clr = Clr.Dark2 },
    PetTargetHealth = {     X = 238-232,              Y = -347.5-19+132,    tX = 396, tY = 38, W = 81,  H = 6, L = "ARTWORK", Clr = Clr.HealthHostile },
    PetTargetPower = {      X = 234-232,              Y = -347.5-26+132,    tX = 396, tY = 45, W = 78,  H = 3, L = "ARTWORK", Clr = Clr.Energy },
    PetTargetLvlBG = {        X = 188-232,              Y = -347.5-11+132,    tX = 372, tY = 38, W = 22,  H = 13, L = "BACKGROUND", Clr = Clr.Dark2, Sub = 1 },
--64,-118
    TargetOrFocusBG = {     X = -35-52 + 60-64,      Y = -120.5-59+118,    tX = 372, tY = 2,  W = 129, H = 35, L = "BACKGROUND", Clr =  Clr.Dark2 },
    TargetOrFocusHealth = { X = -35-52 + 60 + 38-64, Y = -120.5-59-19+118, tX = 396, tY = 38, W = 81,  H = 6, L = "ARTWORK", Clr = Clr.HealthNeutral, RF = "TargetOrFocusBG" },
    TargetOrFocusPower = {  X = -35-52 + 60 + 34-64, Y = -120.5-59-26+118, tX = 396, tY = 45, W = 78,  H = 3, L = "ARTWORK", Clr = Clr.Energy, RF = "TargetOrFocusBG" },
    TargetOrFocusLvlBG = {    X = -35-52 + 60 - 12-64, Y = -120.5-59-11+118, tX = 372, tY = 38, W = 22,  H = 13, L = "ARTWORK", Clr = Clr.Dark2, Sub = 1 },

    --    TargetOrFocusBG = { X = -35-42, Y = -165.5+45, tX = 372, tY = 96, W = 111, H = 29, L = "BACKGROUND" },
    --    TargetOrFocusHealth = { X = -32-42, Y = -178.5+45, tX = 400, tY = 127, W = 80, H = 8, L = "ARTWORK", Clr = Clr.HealthNeutral, RF = "TargetOrFocusBG" },
    --    TargetOrFocusPower = { X = -32-42, Y = -187.5+45, tX = 400, tY = 136, W = 80, H = 4, L = "ARTWORK", Clr = Clr.Energy, RF = "TargetOrFocusBG" },

--    RareElite = { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 3, W = 80, H = 13, L = "ARTWORK", Clr.None},
--    Boss =      { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 18, W = 55, H = 13, L = "ARTWORK", Clr.None},
--    Elite =     { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 33, W = 51, H = 13, L = "ARTWORK", Clr.None},
--    Rare =      { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 48, W = 53, H = 13, L = "ARTWORK", Clr.None},


   },
   Text = {
    ["UnitName"] = { String = "?", X = 169.5, Y = -185, Font = sui.Fonts.Liberation, Size = 11, Flags = "OUTLINE" },
    ["UnitLevel"] = { String = "??", X = 165.5, Y = -204-2, Font = sui.Fonts.Marken, Size = 10, Flags = "OUTLINE" },

    ["PetName"] = { String = "?", X = 229+20+71-232, Y = -283-2+105, Font = sui.Fonts.Marken, Size = 8, Flags = "" },
    ["PetTargetName"] = { String = "?", X = 229+20+71-232, Y = -283-2-67+132, Font = sui.Fonts.Marken, Size = 8, Flags = "" },
    ["TargetOrFocusName"] = { String = "?", X = -35-52 + 60+29+20+71-64, Y = -124 - 60+118, Font = sui.Fonts.Marken, Size = 8, Flags = "", ReversePosition = true },


    ["PetLvl"] = { String = "??", X = 190+11-232, Y = -280.5-13.5+105, Font = sui.Fonts.Marken, Size = 8, Flags = "" },
    ["PetTargetLvl"] = { String = "??", X = 190+11-232, Y = -347.5-13.5+132, Font = sui.Fonts.Marken, Size = 8, Flags = "" },
    ["TargetOrFocusLvl"] = { String = "??", X = -35-52 + 60 -10+11-64, Y = -120.5-59-13.5+118, Font = sui.Fonts.Marken, Size = 8, Flags = "", ReversePosition = true },


    ["UnitHealth"] = { String = "0", X = -45+100-42+13+33, Y = -80-19, Font = sui.Fonts.Marken, Size = 8, Flags = "OUTLINE", Clr = Clr.None },
    ["UnitHealthPercent"] = { String = "0", X = -45+100-42+13+33, Y = -80-19, Font = sui.Fonts.Marken, Size = 8, Flags = "OUTLINE", Clr = Clr.None },

    ["UnitPower"] = { String = "0", X = -45+110-12+15, Y = -95-65-3, Font = sui.Fonts.Marken, Size = 8, Flags = "OUTLINE", Clr = Clr.None },
    ["UnitPowerPercent"] = { String = "0", X = -45+110-12+15, Y = -95-65-3, Font = sui.Fonts.Marken, Size = 8, Flags = "OUTLINE", Clr = Clr.None },

   },
  },
 },
 ComboPoints = {
  Enabled = true,
  TextureSheet = sui.Graphics.Units,
  TextureOffset = {X = 0, Y = 0},
  Frames = { --[ Anchor, OffsetX, OffsetY, Width, Height, X1,X2,Y1,Y2 ]
   Combo = { RT = "CENTER", X = 0, Y = -80, W = 100, H = 20  },
  },
  Textures = {
   C1 = { X = 0, Y = 0, tX = 4, tY = 417, W = 14, H = 14, L = "OVERLAY", Sub = 0, Clr = Clr.Combo },
   C2 = { X = 18, Y = 0, tX = 4, tY = 417, W = 14, H = 14, L = "OVERLAY", Sub = 0, Clr = Clr.Combo },
   C3 = { X = 36, Y = 0, tX = 4, tY = 417, W = 14, H = 14, L = "OVERLAY", Sub = 0, Clr = Clr.Combo },
   C4 = { X = 54, Y = 0, tX = 4, tY = 417, W = 14, H = 14, L = "OVERLAY", Sub = 0, Clr = Clr.Combo },
   C5 = { X = 0, Y = 0, tX = 24, tY = 417, W = 70, H = 14, L = "OVERLAY", Sub = 1, Clr = Clr.Combo },
  }

 },
 PartyFrames = {
  Enabled = false,
  TextureSheet = sui.Graphics.Units,
  TextureOffset = {X = 0, Y = 0},
  Frames = { --[ Anchor, OffsetX, OffsetY, Width, Height, X1,X2,Y1,Y2 ]
   Party1 = { RT = "LEFT", X = 20, Y = 0, W = 139, H = 38  },
   Party2 = { RT = "LEFT", X = 20, Y = -50, W = 139, H = 38  },
   Party3 = { RT = "LEFT", X = 20, Y = -100, W = 139, H = 38  },
   Party4 = { RT = "LEFT", X = 20, Y = -150, W = 139, H = 38  },
   Party5 = { RT = "LEFT", X = 20, Y = -200, W = 139, H = 38  },
  },
  Textures = {
   BG = { X = 0, Y = 0, tX = 117, tY = 456, W = 139, H = 38, L = "BACKGROUND", Clr = Clr.PartyFrame },

   Health = { X = 44, Y = -18, tX = 256, tY = 474, W = 91, H = 7, L = "ARTWORK", Clr = Clr.HealthFriendly },
   IncomingHealth = { X = 44, Y = -18, tX = 256, tY = 474, W = 91, H = 7, L = "BORDER", Clr = Clr.HealthIncoming },

   Power = { X = 41, Y = -26, tX = 256, tY = 482, W = 87, H = 3, L = "ARTWORK", Clr = Clr.Mana },
  
  },
  Text = {
   ["UnitName"] = { String = "?", X = 40.5, Y = -5, Font = sui.Fonts.Liberation, Size = 10, Flags = "OUTLINE" },   
  }
 }

}


SkyBaseClass = SkyUI_CreateClass()
local SkyBaseClass = SkyBaseClass

sui.BaseName = "SkyUI_"

-- SkyBaseClass.Evt = CreateFrame("Frame") -- Event Catcher Frame

-- TexturePath, TextureSize, TextureCoordX, TextureCoordY

function SkyBaseClass.prototype:Hide() self.F:SetAlpha(0) end
function SkyBaseClass.prototype:Show() self.F:SetAlpha(1) end

function SkyBaseClass.prototype:init()
end


function SkyBaseClass.prototype:SetBackground()
 if not self.bgTexture or not self.F then return end

 local t = self.bgTexture
 local g = self.TS
 local bg = self.F:CreateTexture(nil, "BACKGROUND")
 bg:SetTexture(g.Path) -- SpriteSheet
 bg:SetAllPoints(self.F)
 bg:SetTexCoord(t.X / g.W, (t.X + self.W) / g.W, t.Y / g.H, (t.Y + self.H) / g.H)

 bg:Show()
 self.F.texture = bg

 self.F:Show()

end

function SkyBaseClass.prototype:Disable()
 if self.F then self.F:Hide() end
end

function SkyBaseClass.prototype:Enable()
 if self.F then self.F:Show() end
end

function SkyBaseClass.prototype:OffsetTexture(k, offset)
 local g, v = self.TS, self.T[k]
 local x1, x2, y1, y2 = v.tX / g.W, (v.tX + v.W) / g.W, (v.tY + offset) / g.H, (v.tY + v.H + offset) / g.H
 if self.TexturesReversed then
  self.F[k]:SetTexCoord(x2, y1, x2, y2, x1, y1, x1, y2)
 else
  self.F[k]:SetTexCoord(x1, x2, y1, y2)
 end
end

function SkyBaseClass.prototype:AddTextures(Textures)
 if not self.T or not self.F then return end
 local g = self.TS

 if not Textures then Textures = self.T end

 for k,v in pairs(Textures) do
  if not v.Skip then
   local RF = self.F
   if v.RF then RF = self.F[v.RF] end

   self.F[k] = self.F:CreateTexture(sui.BaseName .. self.Name .. k, v.L, nil, v.Sub)
   self.F[k]:SetTexture(g.Path)

   if self.TexturesReversed then v.RT = "TOPRIGHT"
   elseif v.RT == nil then v.RT = "TOPLEFT" end

   self.F[k]:SetSize(v.W, v.H)

   local x1, x2, y1, y2 = v.tX / g.W, (v.tX + v.W) / g.W, v.tY / g.H, (v.tY + v.H) / g.H

   -- x1,y1               x2,y1
   --
   --
   --
   -- x1,y2               x2,y2

   if self.TexturesReversed then

    self.F[k]:SetPoint(v.RT, RF, v.RT, -v.X - self.tO.X, v.Y + self.tO.Y)
    --                                         UL, LL, UR, LR
    self.F[k]:SetTexCoord(x2, y1, x2, y2, x1, y1, x1, y2)
   elseif v.Rotate then
    self.F[k]:SetPoint(v.RT, RF, v.RT, v.X + self.tO.X, v.Y + self.tO.Y)

    --    local ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = x1, y1, x1, y2, x2, y1, x2, y2
    local URx, URy, LRx, LRy, LLx, LLy, ULx, ULy = x2, y1, x2, y2, x1, y2, x1, y1

    local i = v.Rotate
    while i > 0 do
     local t1, t2 = ULx, ULy
     ULx, ULy = LLx, LLy
     LLx, LLy = LRx, LRy
     LRx, LRy = URx, URy
     URx, URy = t1, t2
     i = i - 1
    end
    self.F[k]:SetTexCoord(ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)
   else
    self.F[k]:SetPoint(v.RT, RF, v.RT, v.X + self.tO.X, v.Y + self.tO.Y)
    self.F[k]:SetTexCoord(x1, x2, y1, y2)
    if v.Rotation then self.F[k]:SetRotation(v.Rotation) end
   end
   self.F[k]:Show()
   if v.Clr then self.F[k]:SetVertexColor(v.Clr.r, v.Clr.g, v.Clr.b, v.Clr.a) end
  end
 end

end

function SkyBaseClass.prototype:MaxChars(txt, maxlen)
 while txt:GetStringWidth() > maxlen do txt:SetText(strsub(txt:GetText(), 0, #txt:GetText()-1)) end
end


function SkyBaseClass.prototype:SetText_Justified(f, t, lvl, j, maxlen, xO) -- frame, text, level, justification, maxlength, offset
 if t == "Unknown" then return true end
 if lvl then maxlen = maxlen - 15 end
 if not xO then xO = 0 end
 self.F[f]:SetText(t)
 if maxlen then self:MaxChars(self.F[f], maxlen) end

 -- PetName nil 0 left 60
 if lvl then
  if self.TexturesReversed then self.F[f]:SetText(lvl .. " " .. self.F[f]:GetText())
  else self.F[f]:SetText(self.F[f]:GetText() .. " " .. lvl) end
 end

 local w = self.F[f]:GetStringWidth()
 if j == "CENTER" then w = w / 2 elseif j == "LEFT" then w = 0 end
 -- w = w + o

 if self.TexturesReversed then self.F[f]:SetPoint("TOPRIGHT", self.F, "TOPRIGHT", -self.Txt[f].X - self.tO.X + w + 2 + xO, self.Txt[f].Y + self.tO.Y)
 else self.F[f]:SetPoint("TOPLEFT", self.F, "TOPLEFT", self.Txt[f].X + self.tO.X - w - 2 - xO, self.Txt[f].Y + self.tO.Y) end


end

function SkyBaseClass.prototype:AddText(Txt)
 if not self.Txt or not self.F then return end

 if not Txt then Txt = self.Txt end

 for k,v in pairs(Txt) do
  self.F[k] = self.F:CreateFontString(sui.BaseName .. self.Name .. k, "OVERLAY")
  self.F[k]:SetFont(v.Font, v.Size, v.Flags)
  self.F[k]:ClearAllPoints()

  if self.TexturesReversed then v.RT = "TOPRIGHT"
  elseif v.RT == nil then v.RT = "TOPLEFT" end

  if self.TexturesReversed then
   self.F[k]:SetPoint(v.RT, -v.X - self.tO.X, v.Y + self.tO.Y)
   self.F[k]:SetJustifyH("RIGHT")
  else
   self.F[k]:SetPoint(v.RT, v.X + self.tO.X, v.Y + self.tO.Y)
  end

  self.F[k]:SetText(v.String)

  if v.Clr then self.F[k]:SetVertexColor(v.Clr.r, v.Clr.g, v.Clr.b, v.Clr.a) end
 end

end


function SkyBaseClass.prototype:CreateFrame()
 self.F = CreateFrame("Frame", sui.BaseName .. self.Name, UIParent)
 self.F:SetPoint(self.RT, self.X, self.Y)
 self.F:SetSize(self.W, self.H)
 self.F:Show()
 self.F.sui = self
end

function SkyBaseClass.prototype:MakeMovable()

-- local f = self.F
-- f:EnableMouse(true)
-- local t = self.F:CreateTexture(nil, "OVERLAY")
-- t:SetTexture(1, 0, 0, 0.3) -- SpriteSheet
-- t:SetAllPoints(f)

-- t:SetPoint("TOPLEFT", f, "TOPLEFT", -20, 0)
-- t:SetSize(50, 50)
end

function SkyBaseClass.prototype:CreateSecureHeader()
 self.Header = CreateFrame("Frame", nil, nil, "SecureHandlerStateTemplate")

 if self.Name == "KeyPad" then
  RegisterStateDriver(self.Header, "page", self.GetBar())
  self.Header:SetAttribute("_onstate-page", [[
		if newstate == "possess" or newstate == "11" then
			if HasVehicleActionBar() then
				newstate = GetVehicleBarIndex()
			elseif HasOverrideActionBar() then
				newstate = GetOverrideBarIndex()
			elseif HasTempShapeshiftActionBar() then
				newstate = GetTempShapeshiftBarIndex()
			else
				newstate = nil
			end
			if not newstate then -- cannot determine possess/vehicle action bar page
				newstate = 12
			end
		end
		self:SetAttribute("state", newstate)
		control:ChildUpdate("state", newstate)
 ]])
 end

 self.Header:SetPoint(self.RT, self.X, self.Y)
 self.Header:SetSize(self.W, self.H)
 self.Header:Show()
 self.Header.sui = self
end

function SkyBaseClass.prototype:ConfigLoaded()

end

sui.Modules.Main.OnConfigUpdated = function()
 sui.Modules.UnitFrames.OnConfigUpdated()
 sui.Modules.ComboPoints.OnConfigUpdated()
 sui.Modules.PartyFrames.OnConfigUpdated()
end




function SkyUI_UpdateConfigs()
 --  print(SkyUI.Config.UnitFrames.Enabled)
 -- tcopy(SkyUI.Config, SkyUI.ConfigDefaults)
 -- SkyUI.Config.UnitFrames.targettarget.Enabled = true
 if sui.Config.UnitFrames.UI.Enabled then sui.Modules.UnitFrames.Enable() end
 if sui.Config.ComboPoints.UI.Enabled then sui.Modules.ComboPoints.Enable() end
 if sui.Config.PartyFrames.UI.Enabled then sui.Modules.PartyFrames.Enable() end
 if sui.OnConfigLoaded then sui.OnConfigLoaded() end
 -- if SkyUI.Config.ActionBars.UI.Enabled then SkyUI.Modules.ActionBars.Enable() end
end

local function SkyUI_Unload()
 tcopy(SkyUIConfig, sui.Config)
end



function dumpvar(data)
    -- cache of tables already printed, to avoid infinite recursive loops
    local tablecache = {}
    local buffer = ""
    local padder = "    "
 
    local function _dumpvar(d, depth)
        local t = type(d)
        local str = tostring(d)
        if (t == "table") then
            if (tablecache[str]) then
                -- table already dumped before, so we dont
                -- dump it again, just mention it
                buffer = buffer.."<"..str..">\n"
            else
                tablecache[str] = (tablecache[str] or 0) + 1
                buffer = buffer.."("..str..") {\n"
                for k, v in pairs(d) do
                    buffer = buffer..string.rep(padder, depth+1).."["..k.."] => "
                    _dumpvar(v, depth+1)
                end
                buffer = buffer..string.rep(padder, depth).."}\n"
            end
        elseif (t == "number") then
            buffer = buffer.."("..t..") "..str.."\n"
        else
            buffer = buffer.."("..t..") \""..str.."\"\n"
        end
    end
    _dumpvar(data, 0)
    return buffer
end

local function EventManager(self, evt, ...)
-- if evt == "PLAYER_ENTERING_WORLD" then
--  if sui.SkyCombos and sui.Specs.ComboPoints.Enabled then sui.SkyCombos:new() end
 if evt == "ADDON_LOADED" and ... == "SkyUI" then
  tcopy(sui.Config, sui.ConfigDefaults) -- Set configuration to default values prior to loading global saved variable

  if not SkyUIConfig then SkyUIConfig = {} end -- Create a table for our saved variable if it does not already exist
  --  tcopy(SkyUIConfig, SkyUI.ConfigDefaults) -- uncomment and load wow to set all configurations to defaults

  tcopy(sui.Config, SkyUIConfig) -- Transfer any values that exist in our saved variable to our main configuration
  SkyUI_UpdateConfigs()
  self:UnregisterEvent("ADDON_LOADED")
  
 elseif evt == "PLAYER_LOGOUT" then SkyUI_Unload() end
end

local evt = CreateFrame("Frame") -- Event Catcher Frame
--evt:RegisterEvent("PLAYER_ENTERING_WORLD")
evt:RegisterEvent("ADDON_LOADED") -- Fired when saved variables are loaded
evt:RegisterEvent("PLAYER_LOGOUT")

evt:SetScript("OnEvent", EventManager)



-- DEFAULT_CHAT_FRAME:AddMessage(UIParent:GetEffectiveScale());




-- ChatFrame:Hide()




--MinimapCluster:Hide()





